<?php
// $Id: classroom.access.inc,v 1.1 2009/07/27 14:14:06 osoh Exp $

/**
 * Determines if the current user is teacher or admin ('administer classroom').
 *
 * @param $nid
 *   Item nid. It must be related to a course, an assignment or a response.
 */
function classroom_user_is_teacher_or_admin($nid) {
  global $user;

  if (user_access('administer classroom')) return true;
  $item = node_load(array('nid' => $nid));
  $course = classroom_get_course_for($item);
  return classroom_is_active_as_teacher($user, $course);
}

/**
 * Determines if the current user is student or admin ('administer classroom').
 *
 * @param $nid
 *   Item nid. It must be related to a course, an assignment or a response.
 */
function classroom_user_is_student_or_admin($nid) {
  global $user;

  if (user_access('administer classroom')) return true;
  $item = node_load(array('nid' => $nid));
  $course = classroom_get_course_for($item);
  return classroom_is_active_as_student($user, $course);
}

/**
 * Determines if the current user is associated with the course (as teacher or
 * student) or if she is admin ('administer classroom').
 *
 * @param $nid
 *   Item nid. It must be related to a course, an assignment or a response.
 */
function classroom_user_is_registered_or_admin($nid) {
  global $user;

  if (user_access('administer classroom')) return true;
  $item = node_load(array('nid' => $nid));
  $course = classroom_get_course_for($item);
  return classroom_is_user_active($user, $course);
}
